<template>
  <div class="root">
    <div class="container">
      <div class="header">
        <div class="header-logo-container">
          <img src="../assets/img/battleship.svg" alt class="header-logo">
        </div>
        <div class="header-title">Đocker Battleship</div>
      </div>
      <div class="slider">
        <slid-menu></slid-menu>
      </div>
      <div class="content">
        <div class="monitor">
          <monitor></monitor>
        </div>
        <div class="hexagon-container">
          <div class="hexagon" v-for="(container, key) in containers" :key="key">
          </div>
        </div>
        <div class="term">
          <term></term>
        </div>
      </div>
      <div class="footer">FooterFooterFooterFooter</div>
    </div>
  </div>
</template>

<script>
import SlidMenu from "../components/SlidMenu";
import Term from "./Term";
import Monitor from "./Monitor";

export default {
  components: {
    SlidMenu,
    Term,
    Monitor
  },
  data() {
    return {
      containers: [1, 2, 3, 4, 5, 6, 7, 8, 9, 10],
      container_height: this.getWindowInnerHeight()
    };
  },
  methods: {
    getWindowInnerHeight() {
      return window.innerHeight + "px";
    },
    showHexagonContainers() {
      setInterval(() => {
        this.containers = [...this.containers, 10];
      }, 1000);
    }
  },
  mounted() {
    window.onresize = () => {
      this.container_height = this.getWindowInnerHeight();
    };
    // this.showHexagonContainers();
  }
};
</script>

<style>
@import url("https://fonts.googleapis.com/css?family=Jaldi&display=swap");
:root {
  font-size: 12px;
  --hex-width: 5.8vw;
  --hex-between: 0.5vw;
  --sqrt-3: 1.732050807568877;
  --hex-height: calc(var(--hex-width) / var(--sqrt-3));
  --hex-margin: calc(var(--hex-width) / 2);
  --hex-border: calc(var(--hex-margin) / var(--sqrt-3));
  --hex-transition: all 0.2s ease;
  --color-hex-default: #eee;
  --color-hex-hover: #409eff;
  --color-hex-hover-color: #fff;
  --color-background: rgb(35, 47, 62);
  --color-header-fontend: rgb(4, 101, 229);
  --color-global-bg: rgb(245, 245, 245);
  --color-font-color: #606266;
}
.root {
  background: var(--color-global-bg);
}
.container {
  height: 100vh;
  display: grid;
  grid-template-columns: 12vw auto;
  grid-template-rows: 7vh 91vh 2vh;
  overflow: hidden;
}
.header {
  grid-column-start: 1;
  grid-column-end: 3;
  border-bottom: 1px solid #e3e3e3;
  display: grid;
  grid-template-columns: 12vw auto;
  grid-template-rows: 1fr;
  background-color: var(--color-frame-backgroud);
}
.header-logo {
  height: 7vh;
  width: 7vw;
  margin-left: 2.5vw;
}
.header-title {
  font-family: "Jaldi", sans-serif;
  font-size: 2.5rem;
  line-height: 7vh;
  color: var(--color-header-fontend);
}
.slider {
  overflow: hidden;
}
.content {
  display: grid;
  grid-template-columns: 44vw 44vw;
  grid-template-rows: 168px 1fr;
  justify-content: center;
  overflow: hidden;
}
.term {
  grid-column-start: 2;
  grid-column-end: 3;
  grid-row-start: 2;
  grid-row-end: 3;
  border-left: 1px solid #e3e3e3;
}
.footer {
  grid-column-start: 1;
  grid-column-end: 3;
  background: var(--color-background);
  color: #fff;
}
.hexagon-container {
  grid-column-start: 1;
  grid-column-end: 2;
  grid-row-start: 2;
  grid-row-end: 3;
  display: grid;
  grid-template-columns: repeat(6, var(--hex-width));
  grid-auto-rows: calc(
    var(--hex-width) - (var(--hex-width) / (2 * var(--sqrt-3))) / 2
  );
  grid-gap: var(--hex-between) var(--hex-between);
  justify-content: center;
  margin-top: 1vh;
  overflow: scroll;
  padding-bottom: var(--hex-border);
  left: 1vw;
}
.cicle {
  position: relative;
  display: flex;
  height: 5.8vw;
  width: 5.8vw;
  border-radius: 50%;
  background-color: var(--color-hex-default);
  transition: box-shadow 600ms, background-color 400ms 100ms;
}
.cicle:hover {
  background-color: var(--color-hex-hover);
  color: var(--color-hex-hover-color);
  cursor: pointer;
	box-shadow: 0 4px 8px hsla(208, 100%, 24%, 0.1803921568627451);
}
.cicle:nth-child(12n + 1),
.cicle:nth-child(12n + 2),
.cicle:nth-child(12n + 3),
.cicle:nth-child(12n + 4),
.cicle:nth-child(12n + 5),
.cicle:nth-child(12n + 6) {
  margin-left: calc((var(--hex-width) / 4 + var(--hex-between) / 4) * -1);
}
.cicle:nth-child(12n + 7),
.cicle:nth-child(12n + 8),
.cicle:nth-child(12n + 9),
.cicle:nth-child(12n + 10),
.cicle:nth-child(12n + 11),
.cicle:nth-child(12n + 12) {
  margin-left: calc(var(--hex-width) / 4 + var(--hex-between) / 4);
}
.hexagon {
  align-items: center;
  background-color: var(--color-hex-default);
  cursor: pointer;
  display: flex;
  fill: white;
  color: var(--color-font-color);
  font-weight: bold;
  height: var(--hex-height);
  justify-content: center;
  margin: var(--hex-border) 0;
  position: relative;
  transition: var(--hex-transition);
  width: var(--hex-width);
  animation: showIn 1s;
}
.hexagon::after,
.hexagon::before {
  border-left: var(--hex-margin) solid transparent;
  border-right: var(--hex-margin) solid transparent;
  content: "";
  left: 0;
  position: absolute;
  transition: var(--hex-transition);
  width: 0;
}
.hexagon::after {
  border-top: var(--hex-border) solid var(--color-hex-default);
  top: 100%;
  width: 0;
}
.hexagon::before {
  border-bottom: var(--hex-border) solid var(--color-hex-default);
  bottom: 100%;
}
.hexagon:hover {
  background-color: var(--color-hex-hover);
  color: var(--color-hex-hover-color);
}
.hexagon:hover::after,
.hexagon:hover::before {
  border-top-color: var(--color-hex-hover);
  border-bottom-color: var(--color-hex-hover);
  color: var(--color-hex-hover-color);
}
.hexagon:nth-child(12n + 1),
.hexagon:nth-child(12n + 2),
.hexagon:nth-child(12n + 3),
.hexagon:nth-child(12n + 4),
.hexagon:nth-child(12n + 5),
.hexagon:nth-child(12n + 6) {
  margin-left: calc((var(--hex-width) / 4 + var(--hex-between) / 4) * -1);
}
.hexagon:nth-child(12n + 7),
.hexagon:nth-child(12n + 8),
.hexagon:nth-child(12n + 9),
.hexagon:nth-child(12n + 10),
.hexagon:nth-child(12n + 11),
.hexagon:nth-child(12n + 12) {
  margin-left: calc(var(--hex-width) / 4 + var(--hex-between) / 4);
}
</style>

